--
-- Made for MF 135
--
-- Made by:
-- Martin Schmidt
-- 25/01/10
--
-- Copyright (C) 

SchmidtEngine = {};

function SchmidtEngine.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function SchmidtEngine:load(xmlFile)
	
				
				
	
	self.StartEngine = SpecializationUtil.callSpecializationsFunction("StartEngine");
	self.StopEngine = SpecializationUtil.callSpecializationsFunction("StopEngine");
	
	

	self.EngineRPM = 0;
	self.EngineTemp = 0;

	
    self.Ignition = false;
	
	
	
    self.StopSoundId = createSample("StopSound");
    loadSample(self.StopSoundId, Utils.getFilename("Sound/Out.wav", self.baseDirectory), false);

	self.StartId = createSample("Start");
    loadSample(self.StartId, Utils.getFilename("Sound/Start.wav", self.baseDirectory), false);
	
	self.StarterId = createSample("Starter");
    loadSample(self.StarterId, Utils.getFilename("Sound/Starter.wav", self.baseDirectory), false);
	
	
	self.hornPlaying = false;
	
	
	self.StartTimer = 0;
end;

function SchmidtEngine:keyEvent(unicode, sym, modifier, isDown)

	
    
end;

function SchmidtEngine:StartEngine()
	if not self.hornPlaying then
		playSample(self.StarterId, 0, 1, 0);
		self.hornPlaying = true;
	end;
	Utils.setEmittingState(self.exhaustParticleSystems, true);			
	self.EngineTemp = self.EngineTemp + 0.02;
	
	if self.EngineTemp > 2 then
	
		self.Ignition = true;
		self.StartTimer=75;
		
		playSample(self.StartId, 1, 1, 0);
	    
	end;
end;

function SchmidtEngine:StopEngine()
	self.Ignition = false;
	self.StartTimer=75;
	
	playSample(self.StopSoundId, 1, 1, 0);
end;


function SchmidtEngine:update(dt)
	
	
	if not self.Ignition then
		--Engine Cooling--
		if self.EngineTemp > 0 then
			self.EngineTemp = self.EngineTemp - 0.001;
		else
			self.EngineTemp = 0;
		end;
	else
		--Engine Heating--
		if self.EngineTemp < 90 then
			self.EngineTemp = self.EngineTemp + 0.01;
		end;
	end;
	
	--Engine Reset Timer--
	if self.StartTimer > 0 then
		self.StartTimer = self.StartTimer - 1;
	end;
	
	
	--Engine Starter--
	if self.isEntered then
		if Input.isKeyPressed(Input.KEY_5) then
			if self.StartTimer == 0 then
				if not self.Ignition then
					self:StartEngine();
				else
					self:StopEngine();
				end;
			end;
		else
			if self.hornPlaying then
				stopSample(self.StarterId);
				self.hornPlaying = false;
			end;
			if not self.Ignition then
				Utils.setEmittingState(self.exhaustParticleSystems, false);
			end;
		end;
		
		
		
	end;
    --Engine Starter End--
	
	
	if self.Ignition then
		Utils.setEmittingState(self.exhaustParticleSystems, true);
		if not self.isMotorStarted then
			self:startMotor();
		end;
		
		self.steeringEnabled = true;
	else
		Utils.setEmittingState(self.exhaustParticleSystems, false);
		
		self.steeringEnabled = false;
		self:stopMotor();
	end;
end;

function SchmidtEngine:draw()
	
--   if self.isEntered then
--		renderText(0.8335, 0.25, 0.02, string.format(self.EngineTemp));
		
		
		--TestCode--
--		if self.Ignition then
--			renderText(0.8335, 0.30, 0.02, "Ignition: True");
--		else
--			renderText(0.8335, 0.30, 0.02, "Ignition: False");
--		end;
--	end;
end;

function SchmidtEngine:onEnter()
	self.steeringEnabled = self.Ignition;
	self.isMotorStarted = self.Ignition;
	Utils.setEmittingState(self.exhaustParticleSystems, false)
	
	stopSample(self.IdleId);
end;

function SchmidtEngine:onLeave()
	self.steeringEnabled = false;
	self.isMotorStarted = self.Ignition;
	
	if(self.Ignition) then
		playSample(self.IdleId, 0, 1, 0);
	end;
end;

function SchmidtEngine:delete()
end;

function SchmidtEngine:mouseEvent(posX, posY, isDown, isUp, button)
end;